/*
palettes.h
Copyright 2007-2021 Matt Heinzen

This file is part of Color Machine.

Color Machine is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

Color Machine is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
Color Machine; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __PALETTES_H__
#define __PALETTES_H__

#include "SDL.h"

enum Palette { PALETTE_NONE = 0, PALETTE_RED_PULSE, PALETTE_GREEN_PULSE, PALETTE_BLUE_PULSE,
	PALETTE_YELLOW_PULSE, PALETTE_CYAN_PULSE, PALETTE_MAGENTA_PULSE, PALETTE_RAINBOW,
	PALETTE_BROWNIAN, PALETTE_MAX };

char const* getPaletteName(int paletteIdx);
void initPaletteBlack(SDL_Color *palette);
void initPalette(SDL_Color *palette, int paletteIdx, bool linearPalette);
void copyPalette(SDL_Color *src, SDL_Color *dest);
void rotatePalette(SDL_Color *palette, bool const forward);
void rotateRed(SDL_Color *palette, bool const forward);
void rotateGreen(SDL_Color *palette, bool const forward);
void rotateBlue(SDL_Color *palette, bool const forward);
void fadePalette_x256(SDL_Color *palette, int const nSteps);

#endif // __PALETTES_H__
